Imports DotNetNuke
Imports System.Collections.Generic
Namespace DotNetNuke.Modules
    Partial Class Ajax
        Inherits Entities.Modules.PortalModuleBase
        Dim CurrentPageIndex As Integer

        Protected Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            If Not Page.IsPostBack Then
                ShowData(1)
            End If

        End Sub

        Private Sub ShowData(ByVal intCurrentPageIndex As Integer)

            Dim mySqlString As New StringBuilder()

            mySqlString.Append("SELECT FriendlyName, Description ")
            mySqlString.Append("FROM {databaseOwner}{objectQualifier}DesktopModules ")
            mySqlString.Append("ORDER BY FriendlyName")

            Dim colDesktopModules As New List(Of myDesktopModules)

            Using dr As IDataReader = _
                  CType(DataProvider.Instance().ExecuteSQL(mySqlString.ToString(), Nothing), IDataReader)
                While dr.Read
                    Dim objDesktopModules As New myDesktopModules()
                    objDesktopModules.FriendlyName = Convert.ToString(dr("FriendlyName"))
                    objDesktopModules.Description = Convert.ToString(dr("Description"))
                    colDesktopModules.Add(objDesktopModules)
                End While
            End Using

            Dim pagedData As New PagedDataSource()
            pagedData.DataSource = colDesktopModules
            pagedData.AllowPaging = True
            pagedData.PageSize = 10
            pagedData.CurrentPageIndex = intCurrentPageIndex - 1

            Me.lblTotalPages.Text = Convert.ToString(pagedData.PageCount)
            Me.lblCurrentPage.Text = Convert.ToString(pagedData.CurrentPageIndex + 1)

            If pagedData.IsFirstPage Then
                btnPrevious.Visible = False
            Else
                btnPrevious.Visible = True
            End If
            If pagedData.IsLastPage Then
                btnNext.Visible = False
            Else
                btnNext.Visible = True
            End If

            Me.GridView1.DataSource = pagedData
            Me.GridView1.DataBind()

        End Sub

        Protected Sub Next_Click(ByVal sender As Object, ByVal e As System.EventArgs)
            CurrentPageIndex = Convert.ToInt32(Me.lblCurrentPage.Text) + 1
            ShowData(CurrentPageIndex)
        End Sub

        Protected Sub btnPrevious_Click(ByVal sender As Object, ByVal e As System.EventArgs)
            CurrentPageIndex = Convert.ToInt32(Me.lblCurrentPage.Text) - 1
            ShowData(CurrentPageIndex)
        End Sub
    End Class

    Public Class myDesktopModules
        Dim _FriendlyName As String
        Dim _Description As String
        Public Property FriendlyName() As String
            Get
                Return _FriendlyName
            End Get
            Set(ByVal value As String)
                _FriendlyName = value
            End Set
        End Property
        Public Property Description() As String
            Get
                Return _Description
            End Get
            Set(ByVal value As String)
                _Description = value
            End Set
        End Property
    End Class
End Namespace
